
!include "DotNetChecker.nsh"
!include "FileAssociation.nsh"
##{{NSIS_PLUS_BEGIN_PROJECT_SETTINGS}}##
#NAME "Release"
#	CMD /CD
#	FLAGS 2
##{{NSIS_PLUS_END_PROJECT_SETTINGS}}##

############################################################################################
#      NSIS Installation Script created by NSIS Quick Setup Script Generator v1.09.18
#               Entirely Edited with NullSoft Scriptable Installation System                
#              by Vlasis K. Barkas aka Red Wine red_wine@freemail.gr Sep 2006               
############################################################################################

!define APP_NAME "Silver Monkey"
!define COMP_NAME "TS-Projects"
!define WEB_SITE "http://www.ts-projects.org/smIdx.html"
!ifndef VERSION
!define VERSION "2.20.0.0"
!endif


!define COPYRIGHT "Author Gerolkae  2013"
!define DESCRIPTION "Application"
!define INSTALLER_NAME "SM_Setup(x86)-${VERSION}.exe"
!define MAIN_APP_EXE "SilverMonkey.exe"
!define INSTALL_TYPE "SetShellVarContext all"
!define REG_ROOT "HKLM"
!define REG_APP_PATH "Software\Microsoft\Windows\CurrentVersion\App Paths\${MAIN_APP_EXE}"
!define UNINSTALL_PATH "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APP_NAME}"
!define Bin_Directory "."
!define REG_START_MENU "Start Menu Folder"

Var SM_Folder 



######################################################################

VIProductVersion  "${VERSION}"
VIAddVersionKey "ProductName"  "${APP_NAME}"
VIAddVersionKey "CompanyName"  "${COMP_NAME}"
VIAddVersionKey "LegalCopyright"  "${COPYRIGHT}"
VIAddVersionKey "FileDescription"  "${DESCRIPTION}"
VIAddVersionKey "FileVersion"  "${VERSION}"

######################################################################

SetCompressor ZLIB
Name "${APP_NAME}"
Caption "${APP_NAME}"
OutFile "${INSTALLER_NAME}"

BrandingText "${APP_NAME}"
XPStyle on
InstallDirRegKey "${REG_ROOT}" "${REG_APP_PATH}" ""
InstallDir "$PROGRAMFILES\DSeX"

######################################################################

!include "MUI.nsh"
;!define MUI_ICON "16x16.ico"

!define MUI_ABORTWARNING
!define MUI_UNABORTWARNING

!insertmacro MUI_PAGE_WELCOME

!ifdef LICENSE_TXT
!insertmacro MUI_PAGE_LICENSE "${LICENSE_TXT}"
!endif
!insertmacro MUI_PAGE_DIRECTORY

!ifdef REG_START_MENU
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "SilverMonkey"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "${REG_ROOT}"
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${UNINSTALL_PATH}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "${REG_START_MENU}"
!insertmacro MUI_PAGE_STARTMENU Application "$SM_Folder"
!endif

!insertmacro MUI_PAGE_INSTFILES

!define MUI_FINISHPAGE_RUN "$INSTDIR\${MAIN_APP_EXE}"
!insertmacro MUI_PAGE_FINISH

!insertmacro MUI_UNPAGE_CONFIRM



!insertmacro MUI_UNPAGE_INSTFILES


!insertmacro MUI_UNPAGE_FINISH

!insertmacro MUI_LANGUAGE "English"


######################################################################

Section -MainProgram

${INSTALL_TYPE}
SetOverwrite on
SetOutPath "$INSTDIR"
!insertmacro CheckNetFramework "35"
ExecWait '"$INSTDIR\uninstall.exe" /S _?=$INSTDIR'

File "${Bin_Directory}\*.dll"
File "${Bin_Directory}\*.ini"
File "${Bin_Directory}\MonkeySpeakEditor.exe"
File "${Bin_Directory}\*.chm"
File "${Bin_Directory}\SilverMonkey.exe"
File "${Bin_Directory}\MapSearch.exe"
File "${Bin_Directory}\*.txt"

SectionEnd

######################################################################

Section -Additional
SetOutPath "$INSTDIR\Scripts"
File "${Bin_Directory}\Scripts\*.ini"
;File "${Bin_Directory}\Scripts\*.txt"
SectionEnd


Section -Additional2
SetOutPath "$INSTDIR\Templates"
File "${Bin_Directory}\Templates\*.ds"
;File "${Bin_Directory}\Scripts\*.txt"
SectionEnd

Section -Additional3
SetOutPath "$INSTDIR\Scripts-MS"
File "${Bin_Directory}\Scripts-MS\*.ini"
;File "${Bin_Directory}\Scripts-MS\*.txt"
SectionEnd


Section -Additional4
SetOutPath "$INSTDIR\Templates-MS"
File "${Bin_Directory}\Templates-MS\*.ms"
File "${Bin_Directory}\Templates-MS\*.zip"
;File "${Bin_Directory}\Scripts\*.txt"
SectionEnd

######################################################################

Section -Icons_Reg
SetOutPath "$INSTDIR"
WriteUninstaller "$INSTDIR\uninstall.exe"

!ifdef REG_START_MENU
!insertmacro MUI_STARTMENU_WRITE_BEGIN Application
CreateDirectory "$SMPROGRAMS\$SM_Folder"
CreateShortCut "$SMPROGRAMS\$SM_Folder\${APP_NAME}.lnk" "$INSTDIR\${MAIN_APP_EXE}"
CreateShortCut "$SMPROGRAMS\$SM_Folder\Monkey Speak Editor.lnk" "$INSTDIR\MonkeySpeakEditor.exe"
CreateShortCut "$SMPROGRAMS\$SM_Folder\Scripts.lnk" "$INSTDIR\Scripts"
CreateShortCut "$DESKTOP\${APP_NAME}.lnk" "$INSTDIR\${MAIN_APP_EXE}"
CreateShortCut "$SMPROGRAMS\$SM_Folder\${APP_NAME}.lnk" "$INSTDIR\${MAIN_APP_EXE}"
!ifdef WEB_SITE
WriteIniStr "$INSTDIR\${APP_NAME} website.url" "InternetShortcut" "URL" "${WEB_SITE}"
CreateShortCut "$SMPROGRAMS\$SM_Folder\${APP_NAME} Website.lnk" "$INSTDIR\${APP_NAME} website.url"
!endif
!insertmacro MUI_STARTMENU_WRITE_END
!endif

!ifndef REG_START_MENU
CreateDirectory "$SMPROGRAMS\$SM_Folder"
CreateShortCut "$SMPROGRAMS\$SM_Folder\${APP_NAME}.lnk" "$INSTDIR\${MAIN_APP_EXE}"
CreateShortCut "$SMPROGRAMS\$SM_Folder\Monkey Speak Editor.lnk" "$INSTDIR\MonkeySpeakEditor.exe"
CreateShortCut "$DESKTOP\${APP_NAME}.lnk" "$INSTDIR\${MAIN_APP_EXE}"
!ifdef WEB_SITE
WriteIniStr "$INSTDIR\${APP_NAME} website.url" "InternetShortcut" "URL" "${WEB_SITE}"
CreateShortCut "$SMPROGRAMS\$SM_Folder\${APP_NAME} Website.lnk" "$INSTDIR\${APP_NAME} website.url"
!endif
!endif

WriteRegStr ${REG_ROOT} "${REG_APP_PATH}" "" "$INSTDIR\${MAIN_APP_EXE}"
WriteRegStr ${REG_ROOT} "${UNINSTALL_PATH}"  "DisplayName" "${APP_NAME}"
WriteRegStr ${REG_ROOT} "${UNINSTALL_PATH}"  "UninstallString" "$INSTDIR\uninstall.exe"
WriteRegStr ${REG_ROOT} "${UNINSTALL_PATH}"  "DisplayIcon" "$INSTDIR\${MAIN_APP_EXE}"
WriteRegStr ${REG_ROOT} "${UNINSTALL_PATH}"  "DisplayVersion" "${VERSION}"
WriteRegStr ${REG_ROOT} "${UNINSTALL_PATH}"  "Publisher" "${COMP_NAME}"

!ifdef WEB_SITE
WriteRegStr ${REG_ROOT} "${UNINSTALL_PATH}"  "URLInfoAbout" "${WEB_SITE}"
!endif
SectionEnd

######################################################################

Section Uninstall
${INSTALL_TYPE}
Delete "$INSTDIR\*.*"
Delete "$INSTDIR\Scripts\*.*"
Delete "$INSTDIR\Templates\*.*"
Delete "$INSTDIR\Scripts-MS\*.*"
Delete "$INSTDIR\Templates-MS\*.*"
RmDir "$INSTDIR\Scripts"
RmDir "$INSTDIR\Templates"
RmDir "$INSTDIR\Scripts-MS"
RmDir "$INSTDIR\Templates-MS"
${unregisterExtension} ".ds" "DragonSpeak File"
!ifdef WEB_SITE
Delete "$INSTDIR\${APP_NAME} website.url"
!endif
RmDir "$INSTDIR"

!ifndef NEVER_UNINSTALL
RmDir "$DOCUMENTS\$SM_Folder"
!endif

!ifdef REG_START_MENU
!insertmacro MUI_STARTMENU_GETFOLDER "Application" $SM_Folder
Delete "$SMPROGRAMS\$SM_Folder\${APP_NAME}.lnk"
Delete "$SMPROGRAMS\$SM_Folder\Monkey Speak Editor.lnk"
!ifdef WEB_SITE
Delete "$SMPROGRAMS\$SM_Folder\${APP_NAME} Website.lnk"
!endif
Delete "$DESKTOP\${APP_NAME}.lnk"

RmDir "$SMPROGRAMS\${APP_NAME}"
!endif

!ifndef REG_START_MENU
Delete "$SMPROGRAMS\$SM_Folder}\${APP_NAME}.lnk"
Delete "$SMPROGRAMS\$SM_Folder\${APP_NAME} Help.lnk"
!ifdef WEB_SITE
Delete "$SMPROGRAMS\$SM_Folder\${APP_NAME} Website.lnk"
!endif
Delete "$DESKTOP\${APP_NAME}.lnk"

RmDir "$SMPROGRAMS\${APP_NAME}"
!endif

DeleteRegKey ${REG_ROOT} "${REG_APP_PATH}"
DeleteRegKey ${REG_ROOT} "${UNINSTALL_PATH}"
SectionEnd

######################################################################

