﻿Imports Monkeyspeak
Imports SilverMonkey.ErrorLogging
Imports SilverMonkey.TextBoxWriter
Imports Furcadia.Net.Movement
Imports Furcadia.Net

Public Class FurreList
    Inherits Monkeyspeak.Libraries.AbstractBaseLibrary
    Private writer As TextBoxWriter = Nothing

    Dim FurreList As Dictionary(Of UInteger, FURRE) = DREAM.List

    Public Sub New()
        writer = New TextBoxWriter(Variables.TextBox1)

        '(1:700) and the triggering furre in the dream.
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Condition, 700), AddressOf TriggeringInDream,
"(1:700) and the triggering furre in the dream.")

        '(1:701) and the triggering furre is not in the dream.
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Condition, 701), AddressOf TriggeringNotInDream,
"(1:701) and the triggering furre is not in the dream.")

        '(1:702) and the furre named {...} is in the dream.
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Condition, 702), AddressOf FurreNamedInDream,
"(1:702) and the furre named {...} is in the dream.")

        '(1:703) and the furre named {...} is not in the dream
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Condition, 703), AddressOf FurreNamedNotInDream,
"(1:703) and the furre named {...} is not in the dream")

        '(1:704) and the triggering furre is visible.
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Condition, 704), AddressOf TriggeringCanSee,
"(1:704) and the triggering furre is visible.")

        '(1:705) and the triggering furre is not visible
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Condition, 705), AddressOf TriggeringNotCanSee,
"(1:705) and the triggering furre is not visible")

        '(1:706) and the furre named {...} is visible.
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Condition, 706), AddressOf FurreNamedCanSee,
"(1:706) and the furre named {...} is visible.")

        '(1:707) and the furre named {...} is not visible
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Condition, 707), AddressOf FurreNamedNotCanSee,
"(1:707) and the furre named {...} is not visible")

        '(5:700) Copy the dreams's furre-list to array %Variable
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 700), AddressOf FurreListVar,
"(5:700) Copy the dreams's furre-list to array %Variable")

    End Sub

    '(1:700) and the triggering furre in the dream.
    Function TriggeringInDream(reader As Monkeyspeak.TriggerReader) As Boolean
        Try
            Dim tPlayer As FURRE = callbk.Player
            Return InDream(tPlayer.Name)
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
    End Function

    '(1:701) and the triggering furre is not in the dream.
    Function TriggeringNotInDream(reader As Monkeyspeak.TriggerReader) As Boolean
        Try
            Dim tPlayer As FURRE = callbk.Player
            Return Not InDream(tPlayer.Name)
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
    End Function
    '(1:702) and the furre named {...} is in the dream.
    Function FurreNamedInDream(reader As Monkeyspeak.TriggerReader) As Boolean
        Try
            Dim name As String = reader.ReadString
            name = callbk.LongNameToShortName(name)
            Dim Target As FURRE = callbk.ShortNametoFurre(name)
            Return InDream(Target.Name)
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
    End Function

    '(1:703) and the furre named {...} is not in the dream
    Function FurreNamedNotInDream(reader As Monkeyspeak.TriggerReader) As Boolean
        Try
            Dim name As String = reader.ReadString
            name = callbk.LongNameToShortName(name)
            Dim Target As FURRE = callbk.ShortNametoFurre(name)
            Return Not InDream(Target.Name)
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
    End Function

    '(1:704) and the triggering furre is visible.
    Function TriggeringCanSee(reader As Monkeyspeak.TriggerReader) As Boolean
        Try
            Dim tPlayer As FURRE = callbk.Player
            Return tPlayer.Visible
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
    End Function
    '(1:705) and the triggering furre is not visible
    Function TriggeringNotCanSee(reader As Monkeyspeak.TriggerReader) As Boolean
        Try
            Dim tPlayer As FURRE = callbk.Player
            Return Not tPlayer.Visible
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
    End Function
    '(1:706) and the furre named {...} is visible.
    Function FurreNamedCanSee(reader As Monkeyspeak.TriggerReader) As Boolean
        Try
            Dim name As String = reader.ReadString
            name = callbk.LongNameToShortName(name)
            Dim Target As FURRE = callbk.ShortNametoFurre(name)
            Return Target.Visible
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
    End Function
    '(1:707) and the furre named {...} is not visible
    Function FurreNamedNotCanSee(reader As Monkeyspeak.TriggerReader) As Boolean
        Try
            Dim name As String = reader.ReadString
            name = callbk.LongNameToShortName(name)
            Dim Target As FURRE = callbk.ShortNametoFurre(name)
            Return Not Target.Visible
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
    End Function

    '(5:700) Copy the dreams's furre-list to array %Variable
    Function FurreListVar(reader As Monkeyspeak.TriggerReader) As Boolean
        Try
            Dim var As Monkeyspeak.Variable = reader.ReadVariable(True)
            Dim str As String = ""
            For Each kvp As KeyValuePair(Of UInteger, FURRE) In FurreList
                str += kvp.Value.ShortName + " "
            Next
            var.AssignValue(str)
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
    End Function
#Region "Helper Functions"
    Private Function InDream(ByRef Name As String) As Boolean
        Dim found As Boolean = False
        For Each kvp As KeyValuePair(Of UInteger, FURRE) In FurreList
            If kvp.Value.Name = Name Then
                Return True
            End If
        Next
        Return False
    End Function

#End Region

End Class
