﻿Imports Monkeyspeak
Public Class MS_Dice
    Inherits Monkeyspeak.Libraries.AbstractBaseLibrary
    Private writer As TextBoxWriter = Nothing
    '(5:120) - (5:129)
    Public Sub New()
        writer = New TextBoxWriter(Variables.TextBox1)

        '  (5:120) set variable % to the total of rolling # dice with # sides plus #.
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 130), AddressOf DicePlusNumber, "(5:130) set variable % to the total of rolling # dice with # sides plus #.")

        '  (5:121) set variable % to the total of rolling # dice with # sides minus #.
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 131), AddressOf DiceMinusNumber, "(5:131) set variable % to the total of rolling # dice with # sides minus #.")


    End Sub


    '  (5:312) set variable % to the total of rolling # dice with # sides plus #.
    Public Function DicePlusNumber(reader As Monkeyspeak.TriggerReader) As Boolean
        Dim Var As Monkeyspeak.Variable
        Dim Number As Double
        Dim sides As Double = 0
        Dim NumberPlus As Double = 0
        Dim dice As New DieCollection

        Try
            Var = reader.ReadVariable(True)
            Number = ReadVariableOrNumber(reader)
            sides = ReadVariableOrNumber(reader)
            NumberPlus = ReadVariableOrNumber(reader)
            ' dice.Clear()
            For I As Double = 0 To Number - 1
                dice.Add(New Die(sides))
            Next
            Var.AssignValue(dice.RollAll() + NumberPlus)
            Return True
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
    End Function

    '  (5:313) set variable % to the total of rolling # dice with # sides minus #.
    Public Function DiceMinusNumber(reader As Monkeyspeak.TriggerReader) As Boolean
        Dim Var As Monkeyspeak.Variable = Variable.NoValue
        Dim Number As Double = 0
        Dim NumberVar As Variable = Variable.NoValue
        Dim sides As Double = 0
        Dim sideVar As Variable = Variable.NoValue
        Dim NumberPlus As Double = 0
        Dim NumberPlusVar As Variable = Variable.NoValue
        Dim dice As New DieCollection

        Try
            Var = reader.ReadVariable(True)
            If reader.TryReadVariable(NumberVar) Then
                Number = NumberVar.Value
            Else
                Number = reader.ReadNumber
            End If
            If reader.TryReadVariable(sideVar) Then
                sides = sideVar.Value
            Else
                sides = reader.ReadNumber
            End If
            If reader.TryReadVariable(NumberPlusVar) Then
                NumberPlus = NumberPlusVar.Value
            Else
                NumberPlus = reader.ReadNumber
            End If
            dice.Clear()
            For I As Double = 0 To Number - 1
                dice.Add(New Die(sides))
            Next
            Var.AssignValue(dice.RollAll() - NumberPlus)
            Return True
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
    End Function


    Public Class Die

        Private Shared faceSelector As New Random

        Private _faceCount As Integer
        Private _value As Integer

        Public Property FaceCount() As Integer
            Get
                Return Me._faceCount
            End Get
            Set(ByVal value As Integer)
                Me._faceCount = value
            End Set
        End Property

        Public ReadOnly Property Value() As Integer
            Get
                Return Me._value
            End Get
        End Property

        Public Sub New(ByVal faceCount As Integer)
            If faceCount <= 0 Then
                Throw New ArgumentOutOfRangeException("faceCount", "Dice must have one or more faces.")
            End If

            Me._faceCount = faceCount
        End Sub

        Public Function Roll() As Integer
            Me._value = faceSelector.Next(1, Me.FaceCount + 1)
            Return Me.Value
        End Function

    End Class

    Public Class DieCollection
        Inherits System.Collections.ObjectModel.Collection(Of Die)

        Public Function RollAll() As Integer
            Dim total As Integer = 0

            For Each die As Die In Me.Items
                total += die.Roll()
            Next

            Return total
        End Function

    End Class

End Class
