﻿Imports SilverMonkey.MiscUtils
Imports Monkeyspeak
Imports SilverMonkey.ErrorLogging
Imports SilverMonkey.TextBoxWriter
Imports SilverMonkey.Main
Imports Furcadia.Net
Imports System.IO
Imports System.Text.RegularExpressions

'StringLibrary
'(1:108) - (1:111)
'(5:110) - (5:119)
'MathLibrary

'SayLibrary


''' <summary>
''' Modules Based on SilverMonkey VB Example
''' Modified by Gerolkae
''' Script Loader Moved to SilverMonkey.Main
''' </summary>
Module MS_Engine
    Public callbk As Main
    Public MainMSEngine As MainEngine

    Public Structure ViewArea
        Public X As Integer
        Public Y As Integer
        Public length As Integer
        Public height As Integer
    End Structure

    'Reference http://pastebin.com/QbnjwjNc
    Public Function getTargetRectFromCenterCoord(ByRef X As Integer, ByRef Y As Integer) As ViewArea
        ' Set the size of the rectangle drawn around the player.
        ' The +1 is the tile the player is on.
        Dim rec As ViewArea
        'Dim tilesWide As UInt32 = extraTilesLeft + 7 + 1 + 7 + extraTilesRight
        'Dim tilesHigh As UInt32 = extraTilesTop + 8 + 1 + 8 + extraTilesBottom
        ' NB: these lines *look* similar, but the numbers are for *completely* different reasons!
        'tilesWide = tilesWide * 2 ' * 2 as all X values are even: we count 0, 2, 4...
        'tilesHigh = tilesHigh * 2 ' * 2 as zig-zaggy vertical cols can fit twice as many tiles to a column

        ' Set where in the map our visible (0,0) will be.
        Dim XoddOffset As Integer = 2
        Dim YoddOffset As Integer = 0
        If IsOdd(Y) Then
            XoddOffset = 0
            YoddOffset = 1
        End If
        rec.X = X - 8 + XoddOffset
        rec.Y = Y - 8 - 1 ' 1 for the tile the user is in.
        rec.length = rec.X + 14
        rec.height = rec.Y + 17 + YoddOffset
        Return rec
    End Function



    Class StringLibrary
        Inherits Monkeyspeak.Libraries.AbstractBaseLibrary
        Private writer As TextBoxWriter = Nothing
        Public Sub New()
            writer = New TextBoxWriter(Variables.TextBox1)
            '(1:60) and variable %Variable matches wildcard expression {...} ( ""*"" or ""?""),
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Condition, 60), AddressOf WildCard,
 "(1:60) and variable %Variable matches wildcard expression {...} ( ""*"" or ""?""),")
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Condition, 61), AddressOf NotWildCard,
 "(1:61) and variable %Variable doesn't match wildcard expression {...} ( ""*"" or ""?""),")

            '(5:110) use variable % and take word # and put it into variable %
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 120), AddressOf StringSplit,
             "(5:120) use variable %Variable and take word position # and put it into variable %Variable.")
            '(5:111) use variable % then remove character {...} and put it into variable %.
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 121), AddressOf StripCharacters,
 "(5:121) use variable %Variable then remove all occurrences of character {...} and put it into variable %Variable.")
            '(5:122) chop off the beginning of variable %variable, removing the first # characters of it.
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 122), AddressOf ChopStartString,
"(5:122) chop off the beginning of variable %variable, removing the first # characters of it.")
            '(5:123) chop off the end of variable %Variable, removing the last # characters of it.
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 123), AddressOf ChopEndString,
           "(5:123) chop off the end of variable %Variable, removing the last # characters of it.")

            '(5:124) read line number # from text file {...} and put it into variable %Variable.
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 124), AddressOf ReadTextLine,
           "(5:124) read line number # from text file {...} and put it into variable %Variable.")

            '(5:125) count the number of lines in text file {...} and put it into variable %Variable .
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 125), AddressOf CountLines,
"(5:125) count the number of lines in text file {...} and put it into variable %Variable.")


            '(5:126) count the number of characters in string variable %variable and put them into variable %Variable .
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 126), AddressOf CountChars,
  "(5:126) count the number of characters in string variable %variable and put them into variable %Variable.")

            '(5:127) take variable %Variable and Convert it to Furcadia short name. (with out special Characters or spaces)
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 127), AddressOf ToShortName,
"(5:127) take variable %Variable and convert it to Furcadia short name. (without special characters or spaces or pipe ""|"").")


        End Sub
        '(1:60) and variable %Variable matches wildcard expression {...} ( ""*"" or ""?""),
        Function WildCard(reader As Monkeyspeak.TriggerReader) As Boolean
            Try
                Dim var As Monkeyspeak.Variable = reader.ReadVariable
                Dim Pattern As String = reader.ReadString
                Return MatchWildcardString(Pattern, var.Value)
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function

        '(1:61) and variable %Variable doesn't match wildcard expression {...} ( ""*"" or ""?""),
        Function NotWildCard(reader As Monkeyspeak.TriggerReader) As Boolean
            Try
                Dim var As Monkeyspeak.Variable = reader.ReadVariable
                Dim Pattern As String = reader.ReadString
                Return Not MatchWildcardString(Pattern, var.Value)
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function

        Public Function MatchWildcardString(pattern As [String], input As [String]) As [Boolean]
            If [String].Compare(pattern, input) = 0 Then
                Return True
            ElseIf [String].IsNullOrEmpty(input) Then
                If [String].IsNullOrEmpty(pattern.Trim(New [Char](0) {"*"c})) Then
                    Return True
                Else
                    Return False
                End If
            ElseIf pattern.Length = 0 Then
                Return False
            ElseIf pattern(0) = "?"c Then
                Return MatchWildcardString(pattern.Substring(1), input.Substring(1))
            ElseIf pattern(pattern.Length - 1) = "?"c Then
                Return MatchWildcardString(pattern.Substring(0, pattern.Length - 1), input.Substring(0, input.Length - 1))
            ElseIf pattern(0) = "*"c Then
                If MatchWildcardString(pattern.Substring(1), input) Then
                    Return True
                Else
                    Return MatchWildcardString(pattern, input.Substring(1))
                End If
            ElseIf pattern(pattern.Length - 1) = "*"c Then
                If MatchWildcardString(pattern.Substring(0, pattern.Length - 1), input) Then
                    Return True
                Else
                    Return MatchWildcardString(pattern, input.Substring(0, input.Length - 1))
                End If
            ElseIf pattern(0) = input(0) Then
                Return MatchWildcardString(pattern.Substring(1), input.Substring(1))
            End If
            Return False
        End Function

        '(5:120) use variable % and take word # and put it into variable %
        Function StringSplit(reader As TriggerReader) As Boolean
            Try
                Dim Var As Variable = reader.ReadVariable()
                Dim i As Double = ReadVariableOrNumber(reader)
                Dim NewVar As Variable = reader.ReadVariable(True)
                Dim fields() As String = MiscUtils.Split(Var.Value.ToString, " ", """", True)
                If i < fields.Length Then
                    NewVar.AssignValue(fields(i))
                Else
                    NewVar.AssignValue("")
                End If
                Return True
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function
        '(5:121) use variable % then remove character {...} and put it into variable %.
        Public Function StripCharacters(reader As Monkeyspeak.TriggerReader) As Boolean
            Dim ch As Char = Nothing
            Dim NewVar As Variable
            Dim Var As Variable
            Try
                Var = reader.ReadVariable()
                ch = reader.ReadString
                NewVar = reader.ReadVariable()
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
            Dim varStr As String = Var.Value.ToString
            Dim NewStr As String = varStr.Replace(ch, "")
            NewVar.AssignValue(NewStr)
            Return True
        End Function

        '(5:122) chop off the beginning of variable %variable, removing the first # characters of it.
        Public Function ChopStartString(reader As Monkeyspeak.TriggerReader) As Boolean
            Dim Var As Variable
            Dim Count As Double
            Try
                Var = reader.ReadVariable(True)
                Count = ReadVariableOrNumber(reader)
                Dim str As String = Var.Value.ToString()
                Var.AssignValue(str.Substring(Count))
                Return True
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try


        End Function
        '(5:123) chop off the end of variable %Variable, removing the last # characters of it.
        Public Function ChopEndString(reader As Monkeyspeak.TriggerReader) As Boolean
            Dim Var As Variable
            Dim Count As Double
            Try
                Var = reader.ReadVariable(True)
                Count = reader.ReadNumber()
                Dim str As String = Var.Value.ToString
                Var.AssignValue(str.Substring(0, str.Length - Count))
                Return True
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function

        '(5:124) read line number # from text file {...} and put it into variable %Variable.
        Function ReadTextLine(reader As TriggerReader) As Boolean
            Try
                Dim num As Double = reader.ReadNumber
                Dim File As String = reader.ReadString
                Dim var As Monkeyspeak.Variable = reader.ReadVariable
                Dim i As Integer = 0
                Dim StrReader As New StreamReader(File)
                While Not StrReader.EndOfStream
                    Dim Line As String = StrReader.ReadLine
                    If i = num Then
                        var.AssignValue(Line)
                        Return True
                    End If
                    i += 1
                End While
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function

        '(5:125) count the number of lines in text file {...} and put it into variable %Variable .
        Public Function CountLines(reader As Monkeyspeak.TriggerReader) As Boolean
            Dim File As String = ""
            Dim Var As Monkeyspeak.Variable
            Dim count As Double = 0
            Try
                File = reader.ReadString
                Var = reader.ReadVariable
                Dim test() As String = IO.File.ReadAllLines(File)
                Var.AssignValue(test.Length)
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function

        '(5:126) count the number of characters in string variable %variable and put them into variable %Variable .
        Public Function CountChars(reader As Monkeyspeak.TriggerReader) As Boolean

            Dim var1 As Monkeyspeak.Variable
            Dim var2 As Monkeyspeak.Variable


            Try
                var1 = reader.ReadVariable()
                var2 = reader.ReadVariable(True)
                Dim Count As Double = Convert.ToDouble(var1.Value.length)
                var2.AssignValue(Count)
                Return True
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function

        Private Function ToShortName(reader As TriggerReader) As Boolean
            Try
                Dim var As Monkeyspeak.Variable = reader.ReadVariable
                var.AssignValue(Regex.Replace(var.Value, "[^a-zA-Z0-9\0x0020_.]+", "").ToLower)
                Return True
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function

    End Class


    Class SayLibrary
        Inherits Monkeyspeak.Libraries.AbstractBaseLibrary
        Private writer As TextBoxWriter = Nothing

        Public Sub New()
            writer = New TextBoxWriter(Variables.TextBox1)
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 1,
    Function()
        Return True
    End Function, "(0:1) When the bot logs into furcadia,")
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 2,
Function()
    Return True
End Function, "(0:2) When the bot logs out of furcadia,")
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 3,
Function()
    Return True
End Function, "(0:3) When the Furcadia client disconnects or closes,")

            'says
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 5,
                      Function()
                          '       Console.WriteLine("Cause (0:5):")
                          Return True
                      End Function,
                   "(0:5) When someone says something,")
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 6,
                 AddressOf msgIs, "(0:6) When someone says {...},")

            '(0:7) When some one says something with {...} in it
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 7,
                 AddressOf msgContains, "(0:7) When someone says something with {...} in it,")

            'Shouts
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 8,
           Function()
               Return True
           End Function,
        "(0:8) When someone shouts something,")
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 9,
                 AddressOf msgIs, "(0:9) When someone shouts {...},")

            '(0:10) When some one shouts something with {...} in it
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 10,
                 AddressOf msgContains, "(0:10) When someone shouts something with {...} in it,")

            'emotes
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 11,
           Function()
               Return True
           End Function,
        "(0:11) When someone emotes something,")
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 12,
                 AddressOf msgIs, "(0:12) When someone emotes {...},")

            '(0:13) When some one emotes something with {...} in it
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 13,
                 AddressOf msgContains, "(0:13) When someone emotes something with {...} in it,")

            'Whispers
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 15,
           Function()
               Return True
           End Function,
        "(0:15) When someone whispers something,")
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 16,
                 AddressOf msgIs, "(0:16) When someone whispers {...},")

            '(0:13) When some one emotes something with {...} in it
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 17,
                 AddressOf msgContains, "(0:17) When someone whispers something with {...} in it,")

            'Says or Emotes
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 18,
          Function()
              Return True
          End Function,
       "(0:18) When someone says or emotes something,")
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 19,
                 AddressOf msgIs, "(0:19) When someone says or emotes {...},")

            '(0:13) When some one emotes something with {...} in it
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 20,
                 AddressOf msgContains, "(0:20) When someone says or emotes something with {...} in it,")

            'Emits
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 21,
          Function()
              Return True
          End Function,
       "(0:21) When someone emits something,")
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 22,
                 AddressOf msgIs, "(0:22) When someone emits {...},")

            '(0:13) When some one emotes something with {...} in it
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 23,
                 AddressOf msgContains, "(0:23) When someone emits something with {...} in it,")

            'Furre Enters
            '(0:4) When someone is added to the dream manifest,   
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 24,
          Function()

              Return True
          End Function,
       "(0:24) When someone enters the dream,")
            '(0:25) When a furre Named {...} enters the dream,
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 25,
AddressOf NameIs, "(0:25) When a furre Named {...} enters the dream,")
            'Furre Leaves
            '(0:25) When someone leaves the dream,
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 26,
Function()
    Return True
End Function,
"(0:26) When someone leaves the dream, ")
            '(0:27) When a furre named {...} leaves the dream,
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 27,
AddressOf NameIs, "(0:27) When a furre named {...} leaves the dream")

            'Furre In View
            '(0:28) When someone enters the bots view,
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 28,
AddressOf EnterView, "(0:28) When someone enters the bots view, ")
            '(0:28) When a furre named {...} enters the bots view
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 29,
AddressOf FurreNamedEnterView, "(0:29) When a furre named {...} enters the bots view")
            'Furre Leave View
            '(0:30) When someone leaves the bots view,
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 30,
AddressOf LeaveView,
"(0:30) When someone leaves the bots view, ")
            '(0:31) When a furre named {...} leaves the bots view
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 31,
AddressOf FurreNamedLeaveView, "(0:31) When a furre named {...} leaves the bots view")

            'Summon
            '(0:32) When someone requests to summon the bot,
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 32,
Function()
    Return True
End Function,
"(0:32) When someone requests to summon the bot,")
            '(0:33) When a furre named {...} requests to summon the bot,
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 33,
AddressOf NameIs, "(0:33) When a furre named {...} requests to summon the bot,")
            'Join
            '(0:34) When someone requests to join the bot,
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 34,
Function()
    Return True
End Function,
"(0:34) When someone requests to join the bot,")
            '(0:35) When a furre named {...} requests to join the bot,
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 35,
AddressOf NameIs, "(0:35) When a furre named {...} requests to join the bot,")
            'Follow
            '(0:36) When someone requests to follow the bot,
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 36,
Function()
    Return True
End Function,
"(0:36) When someone requests to follow the bot,")
            '(0:37) When a furre named {...} requests to follow the bot,
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 37,
AddressOf NameIs, "(0:37) When a furre named {...} requests to follow the bot,")
            'Lead
            '(0:38) When someone requests to lead the bot,
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 38,
Function()
    Return True
End Function,
"(0:38) When someone requests to lead the bot,")
            '(0:39) When a furre named {...} requests to lead the bot,
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 39,
AddressOf NameIs, "(0:39) When a furre named {...} requests to lead the bot,")
            'Cuddle
            '(0:40) When someone requests to cuddle with the bot. 
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 40,
Function()
    Return True
End Function,
"(0:40) When someone requests to cuddle with the bot,")
            '(0:41) When a furre named {...} requests to cuddle with the bot,
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 41,
AddressOf NameIs, "(0:41) When a furre named {...} requests to cuddle with the bot,")

            'Trade rewuests



            '(0:46) When the bot sees a trade request,
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 46,
Function()
    Return True
End Function,
"(0:46) When the bot sees a trade request,")
            '(0:47) When the bot sees the trade request {...},
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 47,
                 AddressOf msgIs, "(0:47) When the bot sees the trade request {...}")

            '(0:48) When the bot sees a trade request with {...} in it,
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 48,
                 AddressOf msgContains, "(0:48) When the bot sees a trade request with {...} in it,")


            'Dream
            '(0:90) When the bot enters a dream,
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 90,
     Function()
         Return True
     End Function, "(0:90) When the bot enters a dream,")
            '(0:91) When the bot enters a dream named {...},
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 91,
     AddressOf EnterDreamNamed, "(0:91) When the bot enters a dream named {...},")

            '(0:92) When the bot detects the "Your throat is tired. Please wait a few seconds" message,
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 92,
Function()
    Return True
End Function, "(0:92) When the bot detects the ""Your throat is tired. Please wait a few seconds"" message,")

            '(0:93) When the bot resumes processing after seeing "Your throat is tired" message,
            MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 93,
Function()
    Return True
End Function, "(0:93) When the bot resumes processing after seeing ""Your throat is tired"" message,")


            ' (1:3) and the triggering furre's name is {...},
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Condition, 5), AddressOf NameIs, "(1:5) and the triggering furre's name is {...},")
            ' (1:4) and the triggering furre's name is not {...},
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Condition, 6), AddressOf NameIsNot, "(1:6) and the triggering furre's name is not {...},")

            ' (1:5) and the Triggering Furre's message is {...}, (say, emote, shot, whisper, or emit Channels)
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Condition, 7), AddressOf msgIs, "(1:7) and the triggering furre's message is {...},")
            ' (1:8) and the triggering furre's message contains {...} in it, (say, emote, shot, whisper, or emit Channels)
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Condition, 8), AddressOf msgContains, "(1:8) and the triggering furre's message contains {...} in it,")
            '(1:9) and the triggering furre's message does not contain {...} in it, (say, emote, shot, whisper, or emit Channels)
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Condition, 9), AddressOf msgNotContain, "(1:9) and the triggering furre's message does not contain {...} in it,")
            '(1:10) and the triggering furre's message is not {...}, (say, emote, shot, whisper, or emit Channels)
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Condition, 10), AddressOf msgIsNot, "(1:10) and the triggering furre's message is not {...},")

            '(1:11) and triggering furre's message starts with {...},
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Condition, 11), AddressOf msgStartsWith, "(1:11) and triggering furre's message starts with {...},")
            '(1:12) and triggering furre's message doesn't start with {...},
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Condition, 12), AddressOf msgNotStartsWith, "(1:12) and triggering furre's message doesn't start with {...},")
            '(1:13) and triggering furre's message  ends with {...},
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Condition, 13), AddressOf msgEndsWith, "(1:13) and triggering furre's message  ends with {...},")
            '(1:14) and triggering furre's message doesn't end with {...},
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Condition, 14), AddressOf msgNotEndsWith, "(1:14) and triggering furre's message doesn't end with {...},")

            'Says
            ' (5:0) say {...}. 
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 0),
             Function(reader As Monkeyspeak.TriggerReader)
                 Try
                     Dim msg As String = reader.ReadString()
                     sndSay(msg)
                     Return True
                 Catch ex As Exception
                     Dim tID As String = reader.TriggerId
                     Dim tCat As String = reader.TriggerCategory
                     Console.WriteLine("Error, See Debug Window")
                     Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                     writer.WriteLine(ErrorString)
                     Debug.Print(ErrorString)
                     Return False
                 End Try
             End Function,
             "(5:0) say {...}.")
            'emotes
            ' (5:1) emote {...}. 
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 1),
             Function(reader As Monkeyspeak.TriggerReader)
                 Try
                     Dim msg As String = reader.ReadString
                     sndEmote(msg)
                     Return True
                 Catch ex As Exception
                     Dim tID As String = reader.TriggerId
                     Dim tCat As String = reader.TriggerCategory
                     Console.WriteLine("Error, See Debug Window")
                     Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                     writer.WriteLine(ErrorString)
                     Debug.Print(ErrorString)
                     Return False
                 End Try
             End Function,
             "(5:1) emote {...}.")

            'Shouts
            ' (5:2) shout {...}.         
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 2),
             Function(reader As Monkeyspeak.TriggerReader)
                 Try
                     Dim msg As String = reader.ReadString
                     sndShout(msg)
                     Return True
                 Catch ex As Exception
                     Dim tID As String = reader.TriggerId
                     Dim tCat As String = reader.TriggerCategory
                     Console.WriteLine("Error, See Debug Window")
                     Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                     writer.WriteLine(ErrorString)
                     Debug.Print(ErrorString)
                     Return False
                 End Try
             End Function,
             "(5:2) shout {...}.")

            'Emits
            ' (5:3) emit {...}. 
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 3),
           Function(reader As Monkeyspeak.TriggerReader)
               Try
                   Dim msg As String = reader.ReadString
                   sndEmit(msg)
                   Return True
               Catch ex As Exception
                   Dim tID As String = reader.TriggerId
                   Dim tCat As String = reader.TriggerCategory
                   Console.WriteLine("Error, See Debug Window")
                   Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                   writer.WriteLine(ErrorString)
                   Debug.Print(ErrorString)
                   Return False
               End Try
           End Function,
          "(5:3) Emit {...}.")
            ' (5:4) emitloud {...}. 
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 4),
           Function(reader As Monkeyspeak.TriggerReader)
               Try
                   Dim msg As String = reader.ReadString
                   sndEmitLoud(msg)
                   Return True
               Catch ex As Exception
                   Dim tID As String = reader.TriggerId
                   Dim tCat As String = reader.TriggerCategory
                   Console.WriteLine("Error, See Debug Window")
                   Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                   writer.WriteLine(ErrorString)
                   Debug.Print(ErrorString)
                   Return False
               End Try
           End Function,
          "(5:4) Emitloud {...}.")

            'Whispers
            ' (5:5) whisper {...} to the triggering furre.
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 5),
           Function(reader As Monkeyspeak.TriggerReader)
               Try
                   Dim msg As String = reader.ReadString
                   Dim tname As Variable = MainEngine.MSpage.GetVariable(Main.VarPrefix & "NAME")
                   sndWhisper(tname.Value.ToString, msg)
                   Return True
               Catch ex As Exception
                   Dim tID As String = reader.TriggerId
                   Dim tCat As String = reader.TriggerCategory
                   Console.WriteLine("Error, See Debug Window")
                   Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                   writer.WriteLine(ErrorString)
                   Debug.Print(ErrorString)
                   Return False
               End Try
           End Function,
         "(5:5) whisper {...} to the triggering furre.")

            ' (5:6) whisper {...} to {...}.
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 6),
            Function(reader As Monkeyspeak.TriggerReader)
                Try
                    Dim msg As String = reader.ReadString(True)
                    Dim tname As String = reader.ReadString
                    sndWhisper(tname, msg)
                    Return True
                Catch ex As Exception
                    Dim tID As String = reader.TriggerId
                    Dim tCat As String = reader.TriggerCategory
                    Console.WriteLine("Error, See Debug Window")
                    Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                    writer.WriteLine(ErrorString)
                    Debug.Print(ErrorString)
                    Return False
                End Try
            End Function,
         "(5:6) whisper {...} to {...}.")

            ' (5:7) whisper {...} to {...} even if they're offline.
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 7),
          Function(reader As Monkeyspeak.TriggerReader)
              Try
                  Dim tname As Variable = reader.ReadVariable
                  Dim msg As String = reader.ReadString
                  sndOffWhisper(tname.Value.ToString, msg)
                  Return True
              Catch ex As Exception
                  Dim tID As String = reader.TriggerId
                  Dim tCat As String = reader.TriggerCategory
                  Console.WriteLine("Error, See Debug Window")
                  Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                  writer.WriteLine(ErrorString)
                  Debug.Print(ErrorString)
                  Return False
              End Try
          End Function,
            "(5:7) whisper {...} to {...} even if they're offline.")

            '(5:40) Switch the bot to stand alone mode and close the Furcadia client.
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 40), AddressOf StandAloneMode,
                "(5:40) Switch the bot to stand alone mode and close the Furcadia client.")

            '(5:41) Disconnect the bot from the Furcadia game server.
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 41), AddressOf FurcadiaDisconnect,
                 "(5:41) Disconnect the bot from the Furcadia game server.")

            '(5:42) start a new instance to Silver Monkey with botfile {...}.
            Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 42), AddressOf StartNewBot,
                "(5:42) start a new instance to Silver Monkey with botfile {...}.")

        End Sub

        Function NameIs(reader As TriggerReader) As Boolean
            Try
                Dim TmpName As String = reader.ReadString()
                TmpName = Main.LongNameToShortName(TmpName)
                Dim tname As Variable = MainEngine.MSpage.GetVariable(Main.VarPrefix & "NAME")
                'add Machine Name parser
                Return TmpName = tname.Value
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                'Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                'Debug.Print(ErrorString)
                Return False
            End Try
        End Function

        Function NameIsNot(reader As TriggerReader) As Boolean
            Try
                Dim tname As String = MainEngine.MSpage.GetVariable(Main.VarPrefix & "NAME").Value.ToString
                Dim TmpName As String = reader.ReadString()
                TmpName = Main.LongNameToShortName(TmpName)
                'add Machine Name parser
                If TmpName <> tname Then Return True
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
            Return False
        End Function

        '(0:17) When someone whispers something with {...} in it,
        Function msgContains(reader As TriggerReader) As Boolean
            Dim msMsg As String = ""
            Dim msg As String = ""
            Try
                'Debug.Print("msgContains Begin Execution")
                msMsg = reader.ReadString()
                'Debug.Print("msMsg = " & msMsg)
                msg = MainEngine.MSpage.GetVariable(Main.VarPrefix & "MESSAGE").Value
                'Debug.Print("Msg = " & msg)
                Return msg.Contains(msMsg)
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function

        Function msgNotContain(reader As TriggerReader) As Boolean
            Try
                Dim msMsg As String = reader.ReadString()
                'Debug.Print("msMsg = " & msMsg)
                Dim msg As Variable = MainEngine.MSpage.GetVariable(Main.VarPrefix & "MESSAGE")
                'Debug.Print("Msg = " & msg.Value.ToString)
                If msg.Value.contains(msMsg) Then Return False
                Return True
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function

        Public Function msgIs(reader As TriggerReader) As Boolean
            Try
                Dim msMsg As String = reader.ReadString().ToLower.Trim
                Dim msg As Variable = MainEngine.MSpage.GetVariable(Main.VarPrefix & "MESSAGE")
                Dim test As String = msg.Value.ToString.ToLower.Trim
                Return msMsg = test
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function

        Function msgIsNot(reader As TriggerReader) As Boolean
            Try
                Dim msMsg As String = reader.ReadString()
                Dim msg As Object = MainEngine.MSpage.GetVariable(Main.VarPrefix & "MESSAGE")
                If msMsg.ToLower.Trim <> msg.Value.ToString.ToLower.Trim Then Return True

                Return False
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function

        '(1:11) and triggering furre's message starts with {...},
        Function msgStartsWith(reader As TriggerReader) As Boolean
            Dim msMsg As String = ""
            Dim msg As String = ""
            Try
                'Debug.Print("msgContains Begin Execution")
                msMsg = reader.ReadString().Trim
                'Debug.Print("msMsg = " & msMsg)
                msg = MainEngine.MSpage.GetVariable(Main.VarPrefix & "MESSAGE").Value.trim
                'Debug.Print("Msg = " & msg)
                Dim test As Boolean = msg.StartsWith(msMsg)
                Return msg.StartsWith(msMsg)
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function
        '(1:12) and triggering furre's message doesn't start with {...},
        Function msgNotStartsWith(reader As TriggerReader) As Boolean
            Dim msMsg As String = ""
            Dim msg As String = ""
            Try
                'Debug.Print("msgContains Begin Execution")
                msMsg = reader.ReadString()
                'Debug.Print("msMsg = " & msMsg)
                msg = MainEngine.MSpage.GetVariable(Main.VarPrefix & "MESSAGE").Value
                'Debug.Print("Msg = " & msg)
                Return Not msg.StartsWith(msMsg)
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function
        '(1:13) and triggering furre's message  ends with {...},
        Function msgEndsWith(reader As TriggerReader) As Boolean
            Dim msMsg As String = ""
            Dim msg As String = ""
            Try
                'Debug.Print("msgContains Begin Execution")
                msMsg = reader.ReadString()
                'Debug.Print("msMsg = " & msMsg)
                msg = MainEngine.MSpage.GetVariable(Main.VarPrefix & "MESSAGE").Value
                'Debug.Print("Msg = " & msg)
                Return msg.EndsWith(msMsg)
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function
        '(1:14) and triggering furre's message doesn't end with {...},
        Function msgNotEndsWith(reader As TriggerReader) As Boolean
            Dim msMsg As String = ""
            Dim msg As String = ""
            Try
                'Debug.Print("msgContains Begin Execution")
                msMsg = reader.ReadString()
                'Debug.Print("msMsg = " & msMsg)
                msg = MainEngine.MSpage.GetVariable(Main.VarPrefix & "MESSAGE").Value
                'Debug.Print("Msg = " & msg)
                Return Not msg.EndsWith(msMsg)
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function

        Public Function EnterView(reader As Monkeyspeak.TriggerReader) As Boolean
            Try
                Dim tPlayer As FURRE = callbk.Player
                If tPlayer.Visible = tPlayer.WasVisible Then
                    Return False
                End If
                Return tPlayer.Visible = True
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function
        Public Function FurreNamedEnterView(reader As Monkeyspeak.TriggerReader) As Boolean
            Try
                Dim name As String = reader.ReadString
                Dim tPlayer As FURRE = callbk.ShortNametoFurre(name)
                If tPlayer.Visible = tPlayer.WasVisible Then
                    Return False
                End If
                Return tPlayer.Visible = True

            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function
        Public Function LeaveView(reader As Monkeyspeak.TriggerReader) As Boolean
            Try
                Dim tPlayer As FURRE = callbk.Player
                If tPlayer.Visible = tPlayer.WasVisible Then
                    Return False
                End If
                Return tPlayer.Visible = False
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function
        Public Function FurreNamedLeaveView(reader As Monkeyspeak.TriggerReader) As Boolean
            Try
                Dim name As String = reader.ReadString
                Dim tPlayer As FURRE = callbk.ShortNametoFurre(name)
                If tPlayer.Visible = tPlayer.WasVisible Then
                    Return False
                End If
                Return tPlayer.Visible = False

            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function
        '(0:91) When the bot enters a dream named {...},
        Public Function EnterDreamNamed(reader As Monkeyspeak.TriggerReader) As Boolean
            Try
                Dim msMsg As String = reader.ReadString()
                Dim msg As Variable = MainEngine.MSpage.GetVariable(Main.VarPrefix & "DREAMNAME")
                Dim str As String = msMsg.ToLower.Replace("furc://", "").ToLower
                If str.EndsWith("/") Then str = str.TrimEnd("/")

                Dim str2 As String = msg.Value.ToString.ToLower.Replace("furc://", "")
                If str2.EndsWith("/") Then str2 = str2.TrimEnd("/")

                Return str = str2

            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function
        Public Sub sndSay(ByRef msg As String)
            sendServer(msg)
        End Sub
        Public Sub sndEmote(ByRef msg As String)
            sendServer(":" & msg)
        End Sub
        Public Sub sndShout(ByRef msg As String)
            sendServer("-" & msg)
        End Sub
        Public Sub sndEmit(ByRef msg As String)
            sendServer("emit " & msg)
        End Sub
        Public Sub sndEmitLoud(ByRef msg As String)
            sendServer("emitloud " & msg)
        End Sub
        Public Sub sndWhisper(ByRef name As String, ByRef msg As String)
            sendServer("`wh %" & name & " " & msg)
            ' Debug.Print("wh " & name & " " & msg)
        End Sub
        Public Sub sndOffWhisper(ByRef name As String, ByRef msg As String)
            sendServer("`wh %%" & name & " " & msg)
        End Sub

        Sub sendServer(ByRef var As String)
            callbk.sndServer(var)
        End Sub


        '(5:40) Switch the bot to stand alone mode and close the Furcadia client.
        Public Function StandAloneMode(reader As Monkeyspeak.TriggerReader) As Boolean
            Try
                cBot.StandAlone = True
                callbk.KillProc(callbk.ProcID)
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function
        '(5:41) Disconnect the bot from the Furcadia game server.
        Public Function FurcadiaDisconnect(reader As Monkeyspeak.TriggerReader) As Boolean
            Try
                callbk.DisconnectBot()
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function
        '(5:42) start a new instance to Silver Monkey with botfile {...}.
        Public Function StartNewBot(reader As Monkeyspeak.TriggerReader) As Boolean
            Try
                Dim File As String = reader.ReadString
                Dim p As New ProcessStartInfo
                p.Arguments = File
                p.FileName = "SilverMonkey.exe"
                Process.Start(p)
            Catch ex As Exception
                Dim tID As String = reader.TriggerId
                Dim tCat As String = reader.TriggerCategory
                Console.WriteLine("Error, See Debug Window")
                Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
                writer.WriteLine(ErrorString)
                Debug.Print(ErrorString)
                Return False
            End Try
        End Function
    End Class

    Class MathLibrary
        Inherits Monkeyspeak.Libraries.AbstractBaseLibrary
        Sub New()

        End Sub

    End Class

End Module
