﻿Imports System.IO
Imports System.Text
Imports SilverMonkey.ConfigStructs

Public Class MainEngine


#Region "Const"
    Private Const MS_Header = "*MSPK V04.00 Silver Monkey"
    Private Const MS_Footer = "*Endtriggers* 8888 *Endtriggers*"
#End Region

#Region "MonkeySpeakEngine"
    Public Shared Function MS_Started() As Boolean
        ' 0 = main load
        ' 1 = engine start
        ' 2 = engine running
        If MS_Stared = 2 Then Return True Else Return False
    End Function
    Public Shared MS_Stared As Integer = 0

    Public Shared EngineRestart As Boolean = False

    Public Shared MS_Engine_Running As Boolean = False
    Public engine = New Monkeyspeak.MonkeyspeakEngine()
    Public Shared MSpage As Monkeyspeak.Page
    Public Sub New()
        EngineStart()
    End Sub
    'Bot Starts
    Public Sub ScriptStart()
        Try

            If Not cBot.MS_Engine_Enable Then Exit Sub
            Console.WriteLine("Loading:" & cBot.MS_File)
            Dim start = DateTime.Now
            cBot.MS_Script = msReader(mPath() & "/", cBot.MS_File, True)
            Dim p As String = mPath()
            If String.IsNullOrEmpty(cBot.MS_Script) Then
                Console.WriteLine("ERROR: No script loaded! Aborting")
                MS_Engine_Running = False
                Exit Sub
            End If

            MSpage = engine.LoadFromString(cBot.MS_Script)
            ' Console.WriteLine("Execute (0:0)")
            MS_Stared = 1
            LoadLibrary()
            PageSetVariable(Main.VarPrefix & "MSPATH", mPath())
            PageSetVariable(Main.VarPrefix & "BOTCONTROLLER", callbk.LongNameToShortName(cBot.BotController))
            '(0:0) When the bot starts,
            PageExecute(0)
            Console.WriteLine("Done! Executed in " & DateTime.Now.Subtract(start).ToString())
            'Console.ReadKey()
            MS_Engine_Running = True
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)
        End Try
    End Sub

    'loads at main load
    Public Sub EngineStart()
        Try
            MSpage = engine.LoadFromString("")
            LoadLibrary()
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)
        End Try
    End Sub

    Public Sub LoadLibrary(Optional ByRef start As Boolean = False)
        'Library Loaded?.. Get the Hell out of here

        If MS_Started() Then Exit Sub
        MS_Stared += 1
        MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 0,
             Function()
                 'Console.WriteLine("Trigger (0:0)")
                 'System.Diagnostics.Debug.Print("Trigger (0:0)")
                 Return True
             End Function, "(0:0) When the bot starts,")
        Try
            'Console.WriteLine("Loading Sys  Library")
            MSpage.LoadSysLibrary()
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)
        End Try

        Try
            'Console.WriteLine("Loading IO  Library")
            MSpage.LoadIOLibrary()
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)
        End Try
        Try
            MSpage.LoadTimerLibrary()
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)
        End Try
        MSpage.LoadStringLibrary()
        Try

            'Console.WriteLine("Loading Default Math  Library")
            MSpage.LoadMathLibrary()
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)
        End Try
        'Console.WriteLine("Loading Test  Library")
        Try
            MSpage.LoadLibrary(New StringLibrary()) ' Load our new TestLibrary
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)
        End Try
        'Console.WriteLine("Loading Say  Library")
        Try
            MSpage.LoadLibrary(New SayLibrary())
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)
        End Try

        'Banish Library
        Try
            MSpage.LoadLibrary(New Banish())
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)
        End Try
        'Console.WriteLine("Loading New Math  Library")
        Try
            MSpage.LoadLibrary(New MathLibrary())
            'Define our Triggers before we use them
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)
        End Try

        Try
            MSpage.LoadLibrary(New MS_Time())
            'Define our Triggers before we use them
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)
        End Try
        'Console.WriteLine("Loading New Math  Library")
        Try
            MSpage.LoadLibrary(New MSPK_MDB())
            'Define our Triggers before we use them
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)

        End Try

        Try
            MSpage.LoadLibrary(New MSPK_Web())
            'Define our Triggers before we use them
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)
        End Try
        Try
            MSpage.LoadLibrary(New MS_Cookie())
            MSpage.LoadLibrary(New phoenixspeak())
            'Define our Triggers before we use them
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)
        End Try
        Try
            MSpage.LoadLibrary(New MS_Dice())
            'Define our Triggers before we use them
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)
        End Try
        Try
            MSpage.LoadLibrary(New Description())
            'Define our Triggers before we use them
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)
        End Try
        Try
            MSpage.LoadLibrary(New FurreList())
            'Define our Triggers before we use them
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)
        End Try
        Try
            MSpage.LoadLibrary(New Warning())
            'Define our Triggers before we use them
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)
        End Try
        Try
            MSpage.LoadLibrary(New Movement())
            'Define our Triggers before we use them
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)
        End Try


        Try
            MSpage.LoadLibrary(New WmCpyDta())
            'Define our Triggers before we use them
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)
        End Try

    End Sub

    Private msVer As Double = 3.0
    Public Function msReader(ByVal path As String, ByVal file As String, ByVal E_Mode As Boolean) As String
        file = file.Trim
        Dim Data As String = String.Empty
        Try
            If Not System.IO.File.Exists(path & file.Trim) Then
                Return ""
            End If
            Dim line As String = ""
            Using objReader As New StreamReader(path & file)
                ' line = objReader.ReadLine() & Environment.NewLine
                While objReader.Peek <> -1
                    line = objReader.ReadLine()
                    Data += line + Environment.NewLine

                    If line = MS_KeysIni.GetKeyValue("MS-General", "Footer") And E_Mode Then
                        'ElseIf line = "*Endtriggers* 8888 *Endtriggers*" Then
                        'remainder of the file are Notes
                        'Data += line & Environment.NewLine
                        Exit While
                    End If



                End While
                objReader.Close()
                objReader.Dispose()
            End Using
            Return Data
        Catch eX As Exception
            Dim logError As New ErrorLogging(eX, Me)
            Return ""
        End Try
    End Function

    Public Sub PageSetVariable(ByVal varName As String, ByVal data As Object)
        If cBot.MS_Engine_Enable AndAlso MS_Started() Then
            Try
                MSpage.SetVariable(Main.VarPrefix & varName.ToUpper, data, True) '
            Catch ex As Exception
                Dim logError As New ErrorLogging(ex, Me)
            End Try
        End If
    End Sub
    Public Sub PageSetVariable(ByVal varName As String, ByVal data As Object, ByVal Constant As Boolean)
        If cBot.MS_Engine_Enable AndAlso MS_Started() Then
            Try
                MSpage.SetVariable(Main.VarPrefix & varName.ToUpper, data, Constant) '
            Catch ex As Exception
                Dim logError As New ErrorLogging(ex, Me)
            End Try
        End If
    End Sub

    Public Sub PageExecute(ParamArray ID() As Integer)
        If cBot.MS_Engine_Enable AndAlso MS_Started() Then
            MSpage.Execute(ID)
        End If
    End Sub

#End Region

End Class
