﻿Imports Monkeyspeak
Imports SilverMonkey.ErrorLogging
Imports SilverMonkey.TextBoxWriter
Imports SilverMonkey.Main
Public Class phoenixspeak
    Inherits Monkeyspeak.Libraries.AbstractBaseLibrary
    Private writer As TextBoxWriter = Nothing
    Public Sub New()
        writer = New TextBoxWriter(Variables.TextBox1)
        MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 80,
        Function()
            Return True
        End Function,
     "(0:80) When the bot sees a Phoenix Speak response")
        MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 81,
             AddressOf msgIs, "(0:81) When the bot sees the Phoenix Speak response {...},")

        MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Cause, 82,
             AddressOf msgContains, "(0:82) When the bot sees a Phoenix Speak response with {...} in it,")
        MainEngine.MSpage.SetTriggerHandler(Monkeyspeak.TriggerCategory.Effect, 80,
            AddressOf getPSinfo, "(5:80) retrieve  Phoenix Speak info {...} and place the value into variable %Variable.")

    End Sub


    '(0:17) When someone whispers something with {...} in it,
    Function msgContains(reader As TriggerReader) As Boolean
        Dim msMsg As String = ""
        Dim msg As String = ""
        Try
            'Debug.Print("msgContains Begin Execution")
            msMsg = reader.ReadString()
            'Debug.Print("msMsg = " & msMsg)
            msg = MainEngine.MSpage.GetVariable(Main.VarPrefix & "MESSAGE").Value
            'Debug.Print("Msg = " & msg)
            Return msg.Contains(msMsg)
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
    End Function

    Function msgNotContain(reader As TriggerReader) As Boolean
        Try
            Dim msMsg As String = reader.ReadString()
            'Debug.Print("msMsg = " & msMsg)
            Dim msg As Variable = MainEngine.MSpage.GetVariable(Main.VarPrefix & "MESSAGE")
            'Debug.Print("Msg = " & msg.Value.ToString)
            If msg.Value.contains(msMsg) Then Return False
            Return True
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
    End Function

    Public Function msgIs(reader As TriggerReader) As Boolean
        Try
            Dim msMsg As String = reader.ReadString()
            Dim msg As Variable = MainEngine.MSpage.GetVariable(Main.VarPrefix & "MESSAGE")
            If msMsg = msg.Value.ToString Then Return True
            Return False
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
    End Function

    Function msgIsNot(reader As TriggerReader) As Boolean
        Try
            Dim msMsg As String = reader.ReadString()
            Dim msg As Object = MainEngine.MSpage.GetVariable(Main.VarPrefix & "MESSAGE")
            If msMsg <> msg.Value.ToString Then Return True
            Return False
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
    End Function

    Public Function getPSinfo(reader As Monkeyspeak.TriggerReader) As Boolean
        Try
            Dim Info As String = reader.ReadString()
            Dim var As Monkeyspeak.Variable = reader.ReadVariable(True)
            If Main.PSinfo.ContainsKey(Info) Then
                var.AssignValue(Main.PSinfo.Item(Info))
            Else
                var.AssignValue("")
            End If
            Return True
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
    End Function

End Class
