﻿Imports System.Net
Imports System.Text
Imports System.Web
Imports System.IO
Imports Monkeyspeak
Imports SilverMonkey.ConfigStructs
Imports SilverMonkey.ErrorLogging

'Web Module
'(5:50) - (5:60)
Public Class MSPK_Web
    Inherits Monkeyspeak.Libraries.AbstractBaseLibrary
    Private writer As TextBoxWriter = Nothing
    Private Webrequest As New WebRequests
    Dim WebStack As New Dictionary(Of String, String)
    Public Sub New()
        writer = New TextBoxWriter(Variables.TextBox1)
        'WebStack.Clear()
        '(0:70) When the bot receives a variable list by sending the web stack.
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Cause, 70), _
        Function()
            Return True
        End Function, "(0:70) When the bot receives a variable list by sending the web stack.")

        '(5:50) send post request to Set {key} with a value of {value}, in section {section} on web host.
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 50), AddressOf PostAdd, "(5:50) send post request to set {key} with a value of {value}, in section {section} on web host.")
        '(5:51) send post request to delete the {key} in section {section} on web host.
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 51), AddressOf PostDelete, "(5:51) send post request to delete the {key} in section {section} on web host.")
        '(5:52) send post request to get value for Key {key} in section {section} from webhost and put it into variable %variable.
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 52), AddressOf PostGet, "(5:52) send post request to get value for Key {key} in section {section} from webhost and put it into variable %variable.")
        '(5:53) send post request to update  key {KEY} with a value {Value}, in section {section} on the webhost.

        '(5:54) send get request to set {key} with a value of {value}, in section {section} on web host.
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 54), AddressOf GetSet, "(5:54) send get request to set {key} with a value of {value}, in section {section} on web host.")
        '(5:55) send get request to delete the value for key {key} in section {section} on the webhost.
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 55), AddressOf GetDelete, "(5:55) send get request to delete the value for key {key} in section {section} on the webhost.")
        '(5:56) send get request to get value for Key {key} in section {section} from webhost and put it into variable %variable.
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 56), AddressOf GetGet, "(5:56) send get request to get value for Key {key} in section {section} from webhost and put it into variable %variable.")

        '(5:57) store variable %Variable to the web stack
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 57), AddressOf StoreWebStack, "(5:57) store variable %Variable to the web stack.")
        '(5:58) send post request to send the web stack to the web host.
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 58), AddressOf SendWebStack, "(5:58) send post request to send the web stack to the web host.")
        '(5:59) clear the web stack.
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 59), AddressOf ClearWebStack, "(5:59) clear the web stack.")
        '(5:60) remove variable %Variable from the web stack
        Add(New Monkeyspeak.Trigger(Monkeyspeak.TriggerCategory.Effect, 60), AddressOf RemoveWebStack, "(5:60) remove variable %Variable from the web stack.")


    End Sub

    '(5:50) send post request to add {key} with a value of {value}, in section {section} on web host.
    Function PostAdd(reader As TriggerReader) As Boolean
        Dim Key As String = ""
        Dim Value As String = ""
        Dim Section As String = ""

        Try
            Key = reader.ReadString
            Value = reader.ReadString()
            Section = reader.ReadString

        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
        Dim pager As WebRequests.WebData
        Try
            Dim ws As New WebRequests
            ws.add("Section", Section)
            ws.add("Key", Key)
            ws.add("Value", Value)

            pager = ws.WPost("Set")
            writer.WriteLine(pager.ErrMsg)
            Debug.Print(pager.ErrMsg)
        Catch ex As Exception
            Dim logError As New ErrorLogging(ex, Me)
            Return False
        End Try
        Return Pager.status = 0
    End Function


    '(5:51) send post request to delete the {key} in section {section} on web host.
    Function PostDelete(reader As TriggerReader) As Boolean
        Dim Key As String = ""
        Dim Section As String = ""

        Try
            Key = reader.ReadString
            Section = reader.ReadString
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
        Dim page As WebRequests.WebData
        Try
            Dim ws As New WebRequests
            ws.add("Section", Section)
            ws.add("Key", Key)
            page = ws.WPost("Delete")
            writer.WriteLine(page.ErrMsg)
            Debug.Print(page.ErrMsg)
        Catch ex As Exception
            Dim logError As New ErrorLogging(ex, Me)
            Return False
        End Try
        Return page.Status = 0
    End Function

    '(5:52) send post request to get value for Key {key} in section {section} from webhost and put it into variable %variable.
    Function PostGet(reader As TriggerReader) As Boolean
        Dim Key As String = ""
        Dim Value As String = ""
        Dim Section As String = ""
        Dim myVariable As Monkeyspeak.Variable
        Try
            Key = reader.ReadString
            'Value = reader.ReadString()
            Section = reader.ReadString
            myVariable = reader.ReadVariable

        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
        Dim page As WebRequests.WebData
        Try
            Dim ws As New WebRequests
            ws.add("Section", Section)
            ws.add("Key", Key)
            ' ws.add("Value", TextBox3.Text)
            page = ws.WPost("Get")

            myVariable.AssignValue(page.data)
            writer.WriteLine(page.ErrMsg)
            Debug.Print(page.ErrMsg)
        Catch ex As Exception
            Dim logError As New ErrorLogging(ex, Me)
            Return False
        End Try
        Return page.Status = 0
    End Function

    '(5:50) send post request to add {key} with a value of {value}, in section {section} on web host.
    Function GetSet(reader As TriggerReader) As Boolean
        Dim Key As String = ""
        Dim Value As String = ""
        Dim Section As String = ""

        Try
            Key = reader.ReadString
            Value = reader.ReadString()
            Section = reader.ReadString

        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
        Dim page As WebRequests.WebData
        Try
            Dim ws As New WebRequests
            ws.add("Section", Section)
            ws.add("Key", Key)
            ws.add("Value", Value)
            page = ws.WPost("Set")
            writer.WriteLine(page.ErrMsg)
            Debug.Print(page.ErrMsg)
        Catch ex As Exception
            Dim logError As New ErrorLogging(ex, Me)
            Return False
        End Try
        Return page.Status = 0
    End Function


    '(5:51) send post request to delete the {key} in section {section} on web host.
    Function GetDelete(reader As TriggerReader) As Boolean
        Dim Key As String = ""
        Dim Value As String = ""
        Dim Section As String = ""

        Try
            Key = reader.ReadString
            'Value = reader.ReadString()
            Section = reader.ReadString
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
        Dim page As WebRequests.WebData
        Try
            Dim ws As New WebRequests
            ws.add("Section", Section)
            ws.add("Key", Key)
            'ws.add("Value", Value)
            page = ws.WPost("Delete")
            writer.WriteLine(page.ErrMsg)
            Debug.Print(page.ErrMsg)
        Catch ex As Exception
            Dim logError As New ErrorLogging(ex, Me)
            Return False
        End Try
        Return page.Status = 0
    End Function

    '(5:52) send post request to get value for Key {key} in section {section} from webhost and put it into variable %variable.
    Function GetGet(reader As TriggerReader) As Boolean
        Dim Key As String = ""
        Dim Value As String = ""
        Dim Section As String = ""

        Try
            Key = reader.ReadString
            'Value = reader.ReadString()
            Section = reader.ReadString
            Dim Variable As Monkeyspeak.Variable = reader.ReadVariable

        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
        Dim page As WebRequests.WebData
        Try
            Dim ws As New WebRequests
            ws.add("Section", Section)
            ws.add("Key", Key)
            ' ws.add("Value", TextBox3.Text)
            page = ws.WPost("Get")
            writer.WriteLine(page.ErrMsg)
            Debug.Print(page.ErrMsg)
        Catch ex As Exception
            Dim logError As New ErrorLogging(ex, Me)
            Return False
        End Try
        Return page.Status = 0
    End Function

    '(5:57) store variable %Variable to the web stack
    Private Function StoreWebStack(reader As TriggerReader) As Boolean

        Try
            Dim var As Monkeyspeak.Variable = reader.ReadVariable()
            If WebStack.ContainsKey(var.Name) = False Then
                WebStack.Add(var.Name.Substring(1), var.Value)
            End If
            Return True
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try

    End Function

    '(5:58) send post request to send the web stack to the web host.
    Private Function SendWebStack(reader As TriggerReader) As Boolean

        Dim page As WebRequests.WebData = Nothing
        Dim ws As New WebRequests
        Try
            page = ws.WPost(WebStack)
            WebStack.Clear()
            If page.Status <> 0 Then Throw New WebException(page.ErrMsg)
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
        Return page.Status = 0
    End Function

    ''(5:59) clear the web stack.
    Private Function ClearWebStack(reader As TriggerReader) As Boolean
        WebStack.Clear()
        Return True
    End Function


    '(5:60) remove variable %Variable from the web stack
    Private Function RemoveWebStack(reader As TriggerReader) As Boolean
        Dim var As Monkeyspeak.Variable = Variable.NoValue
        Try
            var = reader.ReadVariable()
        Catch ex As Exception
            Dim tID As String = reader.TriggerId
            Dim tCat As String = reader.TriggerCategory
            Console.WriteLine("Error, See Debug Window")
            Dim ErrorString As String = "Error: (" & tCat & ":" & tID & ") " & ex.Message
            writer.WriteLine(ErrorString)
            Debug.Print(ErrorString)
            Return False
        End Try
        WebStack.Remove(var.Name)
        Return True
    End Function

End Class

Public Class WebRequests
    Dim Ver As Integer = 1
    Public Structure WebData
        Private _Version As Integer
        Private _Status As Integer
        Public ErrMsg As String
        Public Data As String
        Public Packet As String
        Public Property Version As Integer
            Get
                Return _Version
            End Get
            Set(value As Integer)
                _Version = value
            End Set
        End Property
        Public Property Status As Integer
            Get
                Return _Status
            End Get
            Set(value As Integer)
                _Status = value
            End Set
        End Property
    End Structure
    Private UserAgent As String = "Silver Monkey a Furcadia Bot (gerolkae@hotmail.com)"
    Private WebReferer As String = "http://silvermonkey.codeplex.com"
    Dim Addr As String = ""

    Dim data As New Dictionary(Of [String], [String])()
    ' Sample Data

    'Action=[Action]   (Get, Delete, Set)
    'Section=[section]
    'Key={key]
    '*Value=[Value]

    '*Value may not always return from post functions

    Public Sub New()
        'cBot = New cBot
        Addr = cBot.Proto.ToLower & "://" & cBot.Domain & cBot.Path
        data.Clear()
        data.Add("user", cBot.UserName)
        data.Add("password", cBot.Passwd)
    End Sub

    Sub add(ByVal Key As String, ByVal Value As String)
        Try
            data.Add(Key, Value)
        Catch ex As Exception
            data.Item(Key) = Value
        End Try

    End Sub

    Public Function PackURLEncod() As String
        Dim str As String = ""
        For Each row As KeyValuePair(Of String, String) In data
            Dim temp As String = ""
            If row.Value <> "" Then
                temp = HttpUtility.UrlEncode(row.Value)
            End If
            Str += String.Format("{0}={1}&", row.Key, temp)
        Next
        Return str.Substring(0, str.Length - 1)
    End Function

    Public Function WPost(ByVal action As String) As WebData
        Dim Result As WebData = Nothing

        data.Add("action", action)

        Dim encoding As New UTF8Encoding
        Dim str As String = PackURLEncod()
        Dim byteData As Byte() = encoding.GetBytes(str)

        Dim postReq As Net.HttpWebRequest = DirectCast(Net.WebRequest.Create(Addr), Net.HttpWebRequest)
        postReq.Method = "POST"
        postReq.KeepAlive = False
        postReq.ContentType = "application/x-www-form-urlencoded"
        postReq.Referer = WebReferer
        WebReferer = Addr
        postReq.UserAgent = UserAgent
        postReq.ContentLength = byteData.Length
        Try
            Dim postreqstream As Stream = postReq.GetRequestStream()
            postreqstream.Write(byteData, 0, byteData.Length)
            postreqstream.Flush()
            postreqstream.Close()
        Catch ex As Exception
            Result.ErrMsg = ex.Message.ToString
            Result.Version = Ver
            Result.Packet = ""
            Return Result


        End Try

        Try
            Dim postresponse As HttpWebResponse

            postresponse = DirectCast(postReq.GetResponse(), HttpWebResponse)

            Dim postreqreader As New StreamReader(postresponse.GetResponseStream())
            Dim line As String
            Do While Not postreqreader.EndOfStream
                line = postreqreader.ReadLine
                If line <> "MS" Then
                    Result.ErrMsg = "Invalid Format- Not Monkey Speak Responce"
                    Result.Version = Ver
                    Result.Packet = ""
                    Exit Do
                ElseIf line.StartsWith("v=") Then
                    Result.Version = line.Substring(2, line.Length - 1)
                ElseIf line.StartsWith("s=") Then
                    Result.Status = line.Substring(2, line.Length - 1)
                    If line.Substring(2, line.Length - 1) > 0 Then
                        Result.ErrMsg = "There was an error with the request"
                        Exit Do
                    End If
                Else
                    Result.Packet = line
                End If
            Loop

        Catch ex As Exception
            Result.ErrMsg = ex.Message.ToString
            Result.Version = Ver
            Result.Packet = ""
            Return Result
        End Try

        Return Result


    End Function

    Public Function WPost(ByRef stack As Dictionary(Of String, String)) As WebData
        Dim Result As WebData = Nothing

        For Each item As KeyValuePair(Of String, String) In stack
            Dim Key As String = item.Key
            If Key.StartsWith("WWW") Then Key = Key.Substring(3)
            data.Add(Key, item.Value)
        Next
        Dim str As String = PackURLEncod()

        Dim encoding As New UTF8Encoding
        Dim byteData As Byte() = encoding.GetBytes(str)

        Dim postReq As Net.HttpWebRequest = DirectCast(Net.WebRequest.Create(Addr), Net.HttpWebRequest)
        postReq.Method = "POST"
        postReq.KeepAlive = False
        postReq.ContentType = "application/x-www-form-urlencoded"
        postReq.Referer = WebReferer
        postReq.UserAgent = UserAgent
        'postReq.ContentLength = byteData.Length
        Try
            Dim postreqstream As Stream = postReq.GetRequestStream()
            postreqstream.Write(byteData, 0, byteData.Length)
            postreqstream.Flush()
            postreqstream.Close()
        Catch ex As Exception
            Result.ErrMsg = ex.Message.ToString
            Result.Version = Ver
            Result.Packet = ""
            Result.Status = 1
            Return Result


        End Try

        Try
            Dim postresponse As HttpWebResponse

            postresponse = DirectCast(postReq.GetResponse(), HttpWebResponse)

            Dim postreqreader As New StreamReader(postresponse.GetResponseStream())
            Dim line As String
            Dim readKVPs As Boolean = False
            Dim MS As Boolean = False
            Do While Not postreqreader.EndOfStream
                line = postreqreader.ReadLine
                If line = "" Then
                    'Loop

                ElseIf line = "SM" And Not MS Then
                    MS = True
                ElseIf line <> "SM" And Not MS Then
                    line += postreqreader.ReadToEnd
                    Debug.Print(line)
                    line = line.Replace("<br />", vbCrLf)
                    Result.ErrMsg = "Invalid Format- Not Monkey Speak Response" & line
                    Result.Version = Ver
                    Result.Packet = ""
                    Result.Status = 2

                    Exit Do
                ElseIf line = "v=2" Then
                    Result.Version = line.Substring(2)
                    readKVPs = True
                ElseIf line = "v=1" Then
                    Result.Version = line.Substring(2)
                    Result.ErrMsg = "Wrong Version, Expecting Version 2"
                    Result.Packet = ""
                    Result.Status = 2
                    Exit Do
                ElseIf line.StartsWith("s=") Then
                    Result.Status = line.Substring(2)
                    If line.Substring(2) > 0 Then
                        Result.ErrMsg = "There was an error with the request"
                        Exit Do
                    End If
                Else
                    If readKVPs Then
                        Dim pos As Integer = line.IndexOf("=")
                        Dim key As String = line.Substring(0, pos)
                        If key.StartsWith("WWW") = False Then key = "WWW" & key
                        Dim Value As String = line.Substring(pos + 1)

                        'Assign Variables
                        MainMSEngine.PageSetVariable(key, Value, False)

                    End If

                End If
            Loop

            'trigger (0: )
            MainMSEngine.PageExecute(70)

        Catch ex As Exception
            Result.ErrMsg = ex.Message.ToString
            Result.Version = Ver
            Result.Packet = ""
            Result.Status = 4
            Return Result
        End Try

        Return Result


    End Function

    Public Function WGet(ByVal action As String) As WebData
        Dim result As WebData = Nothing

        data.Add("action", action)
        Dim str As String = PackURLEncod()
        Dim requesttring As String = Addr & "?" & str
        Dim request As Net.HttpWebRequest = DirectCast(Net.WebRequest.Create(requesttring), Net.HttpWebRequest)
        request.UserAgent = UserAgent
        request.Referer = WebReferer
        'request.Method = "GET"
        WebReferer = Addr
        Dim packet As String = ""
        Try
            Dim response As HttpWebResponse = DirectCast(request.GetResponse(), HttpWebResponse)
            Dim postreqreader As New StreamReader(response.GetResponseStream())

            Dim line As String
            Do While Not postreqreader.EndOfStream
                line = postreqreader.ReadLine
                If line <> "MS" Then
                    result.ErrMsg = "Invalid Format- Not Monkey Speak Response"
                    result.Version = Ver
                    result.Packet = ""
                    Exit Do
                ElseIf line.StartsWith("v=") Then
                    result.Version = line.Substring(2, line.Length - 1)
                ElseIf line.StartsWith("s=") Then
                    result.Status = line.Substring(2, line.Length - 1)
                    If line.Substring(2, line.Length - 1) > 0 Then
                        result.ErrMsg = "There was an error with the request"
                        Exit Do
                    End If
                Else
                    result.Packet = line
                End If
            Loop

        Catch ex As Exception
            result.ErrMsg = ex.Message.ToString
            result.Version = Ver
            result.Packet = ""
            Return result
        End Try

        Return result

    End Function
End Class
